'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _compact = require('lodash/compact');

var _compact2 = _interopRequireDefault(_compact);

var _uniq = require('lodash/uniq');

var _uniq2 = _interopRequireDefault(_uniq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WebpackWatchPlugin = function () {
  function WebpackWatchPlugin() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _ref$files = _ref.files,
        files = _ref$files === undefined ? [] : _ref$files,
        verbose = _ref.verbose,
        globOptions = _objectWithoutProperties(_ref, ['files', 'verbose']);

    _classCallCheck(this, WebpackWatchPlugin);

    this.files = files;
    this.verbose = !!verbose;
    this.globOptions = _extends({
      absolute: true
    }, globOptions);

    this.filesAlreadyAdded = false;
  }

  _createClass(WebpackWatchPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      // webpack 4 hooks
      (compiler.hooks ? compiler.hooks.afterCompile.tapAsync.bind(compiler.hooks.afterCompile, 'WebpackWatchPlugin') : compiler.plugin.bind(compiler, 'after-compile'))(function (compilation, callback) {
        var filesFound = [];
        var filesFoundToEclude = [];
        _this.files.map(function (pattern) {
          if (pattern.substr(0, 1) !== '!') {
            _glob2.default.sync(pattern, _this.globOptions).map(function (file) {
              return filesFound.push(file);
            });
          } else {
            _glob2.default.sync(pattern.substr(1), _this.globOptions).map(function (file) {
              return filesFoundToEclude.push(file);
            });
          }
        });

        var files = (0, _uniq2.default)((0, _compact2.default)(filesFound.map(function (file) {
          if (~filesFoundToEclude.indexOf(file)) {
            return;
          }
          return file;
        })));

        if (_this.verbose && !_this.filesAlreadyAdded) {
          console.log('Additional files watched : ', JSON.stringify(files, null, 2));
        }

        if (Array.isArray(compilation.fileDependencies)) {
          files.map(function (file) {
            return compilation.fileDependencies.push(file);
          });
        } else {
          files.map(function (file) {
            return compilation.fileDependencies.add(file);
          });
        }

        _this.filesAlreadyAdded = true;
        callback();
      });
    }
  }]);

  return WebpackWatchPlugin;
}();

exports.default = WebpackWatchPlugin;